using System.Linq;
using BenjaminSchroeter.Flow.DataFlow;
using BenjaminSchroeter.Flow.HardwareDescription;
using Input=BenjaminSchroeter.Flow.DataFlow.Input;
using Output=BenjaminSchroeter.Flow.DataFlow.Output;
using Variable=BenjaminSchroeter.Flow.DataFlow.Variable;

namespace BenjaminSchroeter.Flow.CodeGen
{
    static class DataFlowExtensions
    {
        /// <summary>
        /// Gets the Definition from the HardwareDescriptionModel of a DataFlow element.
        /// </summary>
        public static EnableableDomainClass Definition(this DefinitionBase element, HardwareDescriptionModel model)
        {
            if (element is Variable)
            {
                foreach (Platform platform in model.Platforms)
                {
                    BenjaminSchroeter.Flow.HardwareDescription.Variable x = platform.Variables.FirstOrDefault(a => a.Guid.Equals(element.Guid));
                    if (x != null)
                        return x;
                }
            }

            if (element is Input)
            {
                foreach (Platform platform in model.Platforms)
                {
                    BenjaminSchroeter.Flow.HardwareDescription.Input x = platform.Inputs.FirstOrDefault(a => a.Guid.Equals(element.Guid));
                    if (x != null)
                        return x;
                }
            }

            if (element is Output)
            {
                foreach (Platform platform in model.Platforms)
                {
                    BenjaminSchroeter.Flow.HardwareDescription.Output x = platform.Outputs.FirstOrDefault(a => a.Guid.Equals(element.Guid));
                    if (x != null)
                        return x;
                }
            }

            if (element is InputEvent)
            {
                foreach (Platform platform in model.Platforms)
                {
                    BenjaminSchroeter.Flow.HardwareDescription.Event x = platform.Events.FirstOrDefault(a => a.Guid.Equals(element.Guid));
                    if (x != null)
                        return x;
                }
            }

            return null;
        }
    }
}
