using System.Runtime.InteropServices;
using Microsoft.VisualStudio.Shell.Interop;

namespace BenjaminSchroeter.Flow.DataFlow
{
    /// <summary>
    /// This service provides an interface to open a (custom) editor for
    /// CodeBlock shapes. For CodeBlocks the user needs some place where he
    /// can put the code for this block. 
    /// The DataFlow DSL Editor will use this service whenever the
    /// user request to edit the code of the CodeBlock.
    /// </summary>
    [Guid("C93FD556-DEA8-4d31-A462-CD02A2F5CE9B")]
    [ComVisible(true)]
    public interface ICodeBlockEditor
    {
        /// <summary>
        /// Opens the code block editor.
        /// </summary>
        /// <param name="codeblock">The codeblock to open in the editor.</param>
        /// <param name="modelName">Name of the dataflow model.</param>
        /// <param name="hierarchy">The hierarchy item of the dataflow model.</param>
        void OpenCodeBlockEditor(CodeBlock codeblock, string modelName, IVsHierarchy hierarchy);
    }
}
