using Microsoft.VisualStudio.Modeling;

namespace BenjaminSchroeter.Flow.DataFlow
{
    class CodeBlockFieldNameProvider : ElementNameProvider 
    {
        public override void SetUniqueName(ModelElement element, ModelElement container, DomainRoleInfo embeddedDomainRole, string baseName)
        {
            // this creates names like "Input1", "Input2", "Input3" instead of "CodeBlockInputField1", "CodeBlockInputField2" ...

            if (element is CodeBlockInputField)
                baseName = "Input";
            else if (element is CodeBlockOutputField)
                baseName = "Output";

            base.SetUniqueName(element, container, embeddedDomainRole, baseName);
        }
    }
}
