 
using System;
using System.Collections.ObjectModel;
using BenjaminSchroeter.Dsl.CompartmentMapping;
using Microsoft.VisualStudio.Modeling;
using Microsoft.VisualStudio.Modeling.Diagrams.GraphObject;

namespace BenjaminSchroeter.Flow.DataFlow
{
	#region Code for ConnectionBuilder 'FlowElementReferencesTargetFlowElements'
    [RuleOn(typeof(FieldBase), FireTime = TimeToFire.LocalCommit)]
    public partial class SourceOrTargetOfFlowElementReferencesTargetFlowElementsDeletingRule : CompartmentEntryDeletingRuleBase<FlowElement, FieldBase, FlowElementReferencesTargetFlowElements, FlowElement, FieldBase>
    {
        protected override CompartmentMappingBuilderBase<FlowElement, FieldBase, FlowElementReferencesTargetFlowElements, FlowElement, FieldBase> GetBuilderInstance()
        {
            return FlowElementReferencesTargetFlowElementsBuilder.builder;
        }
    }

    public class FlowElementReferencesTargetFlowElementsRouter : CompartmentMappingRouterBase<FlowElement, FieldBase, FlowElementReferencesTargetFlowElements, FlowElement, FieldBase>
    {
        protected override CompartmentMappingBuilderBase<FlowElement, FieldBase, FlowElementReferencesTargetFlowElements, FlowElement, FieldBase> GetBuilderInstance()
        {
            return FlowElementReferencesTargetFlowElementsBuilder.builder;
        }
    }

    public partial class FlowElementReferencesTargetFlowElementsBuilder
    {
        internal static readonly FlowElementReferencesTargetFlowElementsBuilderInstance builder = new FlowElementReferencesTargetFlowElementsBuilderInstance();

        public static bool CanAcceptSource(ModelElement candidate)
        {
            return builder.CanAcceptSource(candidate);
        }

        public static bool CanAcceptTarget(ModelElement candidate)
        {
            return builder.CanAcceptTarget(candidate);
        }

        public static bool CanAcceptSourceAndTarget(ModelElement candidateSource, ModelElement candidateTarget)
        {
            return builder.CanAcceptSourceAndTarget(candidateSource, candidateTarget);
        }

        public static ElementLink Connect(ModelElement source, ModelElement target)
        {
            return builder.Connect(source, target);
        }
    }

	// Create this partial class in another file and implement at least the abstract methods!
    public partial class FlowElementReferencesTargetFlowElementsBuilderInstance : CompartmentMappingBuilderBase<FlowElement, FieldBase, FlowElementReferencesTargetFlowElements, FlowElement, FieldBase>
    {
        internal FlowElementReferencesTargetFlowElementsBuilderInstance()
            : base(
                true,		/* connection.Source.AllowHead */
                true,		/* connection.Target.AllowHead */
                false,	/* connection.AllowSelfReference */	
                false		/* connection.AllowsDuplicates */	)
        {
        }
        
        /// <summary>
        /// Gets all links for the Connection used by this ConnectionBuilderInstance.
        /// </summary>
        /// <remarks>Only a static method of the connection instance can get ths links</remarks>
        /// <param name="source">The source.</param>
        /// <param name="target">The target.</param>
        /// <returns></returns>
		protected override ReadOnlyCollection<FlowElementReferencesTargetFlowElements> GetLinks(FlowElement source, FlowElement target)
        {
			// delegates this call to the static method of the connection class (FlowElementReferencesTargetFlowElements)
            return FlowElementReferencesTargetFlowElements.GetLinks(source, target);
        }
    }	
	#endregion

	#region Code for CompartmentShape 'BaseCompartmentShape'
    partial class BaseCompartmentShape : ICompartmentMouseActionTrackable
    {
        private readonly CompartmentMouseTrack mouseTrack = new CompartmentMouseTrack();

        public CompartmentMouseTrack MouseTrack
        {
            get { return mouseTrack; }
        }

        public override void OnShapeInserted()
        {
            mouseTrack.ShapeInserted(this);
            base.OnShapeInserted();
        }
        
        public override void OnAbsoluteBoundsChanged(Microsoft.VisualStudio.Modeling.Diagrams.AbsoluteBoundsChangedEventArgs e)
        {
            CompartmentMappingUtil.RerouteCompartmentMappings(this);
            base.OnAbsoluteBoundsChanged(e);
        }
    }
	#endregion
	#region Code for CompartmentShape 'CodeBlockShape'
    partial class CodeBlockShape : ICompartmentMouseActionTrackable
    {
        private readonly CompartmentMouseTrack mouseTrack = new CompartmentMouseTrack();

        public CompartmentMouseTrack MouseTrack
        {
            get { return mouseTrack; }
        }

        public override void OnShapeInserted()
        {
            mouseTrack.ShapeInserted(this);
            base.OnShapeInserted();
        }
        
        public override void OnAbsoluteBoundsChanged(Microsoft.VisualStudio.Modeling.Diagrams.AbsoluteBoundsChangedEventArgs e)
        {
            CompartmentMappingUtil.RerouteCompartmentMappings(this);
            base.OnAbsoluteBoundsChanged(e);
        }
    }
	#endregion

	#region Code for Shape 'VariableShape'
    partial class VariableShape
    {
        public override void OnAbsoluteBoundsChanged(Microsoft.VisualStudio.Modeling.Diagrams.AbsoluteBoundsChangedEventArgs e)
        {
            CompartmentMappingUtil.RerouteCompartmentMappings(this);
            base.OnAbsoluteBoundsChanged(e);
        }
    }
	#endregion
	#region Code for Shape 'OperatorShape'
    partial class OperatorShape
    {
        public override void OnAbsoluteBoundsChanged(Microsoft.VisualStudio.Modeling.Diagrams.AbsoluteBoundsChangedEventArgs e)
        {
            CompartmentMappingUtil.RerouteCompartmentMappings(this);
            base.OnAbsoluteBoundsChanged(e);
        }
    }
	#endregion
	#region Code for Shape 'FormulaShape'
    partial class FormulaShape
    {
        public override void OnAbsoluteBoundsChanged(Microsoft.VisualStudio.Modeling.Diagrams.AbsoluteBoundsChangedEventArgs e)
        {
            CompartmentMappingUtil.RerouteCompartmentMappings(this);
            base.OnAbsoluteBoundsChanged(e);
        }
    }
	#endregion
	#region Code for Shape 'MasterTriggerShape'
    partial class MasterTriggerShape
    {
        public override void OnAbsoluteBoundsChanged(Microsoft.VisualStudio.Modeling.Diagrams.AbsoluteBoundsChangedEventArgs e)
        {
            CompartmentMappingUtil.RerouteCompartmentMappings(this);
            base.OnAbsoluteBoundsChanged(e);
        }
    }
	#endregion

	#region Code for Connector 'Connector'
    partial class Connector
    {
        public override void OnInitialize()
        {
            this.FixedFrom = VGFixedCode.Caller;
            this.FixedTo = VGFixedCode.Caller;
            base.OnInitialize();
        }

        public override bool CanManuallyRoute
        {
            get
            {
                return false;
            }
        }
    }
    
    [RuleOn(typeof(Connector), FireTime = TimeToFire.LocalCommit)]
    public class ConnectorAddRule : CompartmentMappingAddRuleBase
    {
    }
	#endregion
}
