
namespace BenjaminSchroeter.Flow.DataFlow
{
    partial class ConnectorBase
    {
        /// <summary>
        /// This method decides whether the target annotation of the connector will be visible.
        /// </summary>
        /// <remarks>
        /// It is only visible if the target of this connection is a Formula
        /// </remarks>
        /// <returns></returns>
        public bool GetTargetAnnotationVisibleValue()
        {
            FlowElementReferencesTargetFlowElements r = this.ModelElement as FlowElementReferencesTargetFlowElements;
            if (r != null)
                return r.TargetFlowElement is Formula;

            return false;
        }
    }
}
