using BenjaminSchroeter.Dsl.UserRestrictions;

namespace BenjaminSchroeter.Flow.DataFlow
{
    [CustomRestrictedProperty("TargetAnnotation")]
    partial class FlowElementReferencesTargetFlowElements : ISupportsUserRestrictions
    {
        /// <summary>
        /// Hides the "TargetAnnotation" property if the target of the connector is not a formula shape
        /// </summary>
        /// <param name="property"></param>
        /// <returns></returns>
        public Restriction GetRestriction(string property)
        {
            if (property != "TargetAnnotation")
                return Restriction.Full;

            return this.TargetFlowElement is Formula ? Restriction.Full : Restriction.Hidden;
        }
    }
}
