using System.Collections.Generic;
using System.Text;

namespace BenjaminSchroeter.Flow.DataFlow
{
    partial class DataFlowDirectiveProcessor
    {
        // Adds the FileName to the DataFlowDirectiveProcessor

        protected override void GenerateTransformCode(string directiveName, StringBuilder codeBuffer, System.CodeDom.Compiler.CodeDomProvider languageProvider, IDictionary<string, string> requiresArguments, IDictionary<string, string> providesArguments)
        {
            base.GenerateTransformCode(directiveName, codeBuffer, languageProvider, requiresArguments, providesArguments);           
            
            // it would be better to use the codedom like in the base method but this is much shorter and works great as well
            codeBuffer.AppendFormat("public string {1} = @\"{0}\";",requiresArguments["FileName"],providesArguments["FileName"]);
            codeBuffer.AppendLine();
        }

        protected override void InitializeProvidesDictionary(string directiveName, IDictionary<string, string> providesDictionary)
        {
            base.InitializeProvidesDictionary(directiveName, providesDictionary);

            providesDictionary.Add("FileName","FileName");
        }
    }
}
