using Microsoft.VisualStudio.Modeling;

namespace BenjaminSchroeter.Flow.DataFlow
{
    /// <summary>
    /// If a FlowElementReferencesTargetFlowElements os deleteted
    /// the Type of the Formula must be invalidated.
    /// </summary>
    [RuleOn(typeof(FlowElementReferencesTargetFlowElements), FireTime = TimeToFire.LocalCommit)]
    class InvalidateFormulaTypeOnLinkDeleteRule : DeleteRule
    {
        public override void ElementDeleted(ElementDeletedEventArgs e)
        {
            Formula f = (e.ModelElement as FlowElementReferencesTargetFlowElements).TargetFlowElement as Formula;
            if (f != null) f.InvalidateType();
        }
    }
}