using Microsoft.VisualStudio.Modeling;

namespace BenjaminSchroeter.Flow.DataFlow
{
    /// <summary>
    /// If on a Formula the Text or on a FlowElementReferencesTargetFlowElements the annotations chages
    /// the Type of the Formula must be invalidated.
    /// </summary>
    [RuleOn(typeof(Formula), FireTime = TimeToFire.LocalCommit)]
    [RuleOn(typeof(FlowElementReferencesTargetFlowElements), FireTime = TimeToFire.LocalCommit)]
    class InvalidateFormulaTypeOnPropertyChangeRule : ChangeRule
    {
        public override void ElementPropertyChanged(ElementPropertyChangedEventArgs e)
        {
            if (e.DomainProperty.Id.Equals(FlowElementReferencesTargetFlowElements.TargetAnnotationDomainPropertyId))
                ((e.ModelElement as FlowElementReferencesTargetFlowElements).TargetFlowElement as Formula).InvalidateType();

            if( e.DomainProperty.Id.Equals(Formula.FormulaTextDomainPropertyId)  )
                (e.ModelElement as Formula).InvalidateType();
        }
    }
}
