namespace BenjaminSchroeter.Flow.DataFlow
{
    partial class FlowBase
    {
        /// <summary>
        /// Gets the DataFlowModel containing this FlowBase.
        /// </summary>
        /// <remarks>
        /// This extra method is needed since only the subclasses TriggerFlow
        /// and ProgramFlow know the DataFlowModel
        /// </remarks>
        /// <returns></returns>
        public DataFlowModel GetDataFlowModel()
        {
            if (this is TriggerFlow)
                return (this as TriggerFlow).DataFlowModel;

            if (this is ProgramFlow)
                return (this as ProgramFlow).DataFlowModel;

            return null;
        }
    }
}
