using System;
using System.Linq;

namespace BenjaminSchroeter.Flow.DataFlow
{
    partial class FlowElementReferencesTargetFlowElements
    {
        public FieldBase SourceField
        {
            get
            {
                return GetField(this.SourceFlowElement, this.SourceEntry);
            }
        }

        public FieldBase TargetField
        {
            get
            {
                return GetField(this.TargetFlowElement, this.TargetEntry);
            }
        }

        private static FieldBase GetField(FlowElement element, Guid entry)
        {
            if (entry.Equals(Guid.Empty))
                return null;

            FieldedDefinitionBase e = element as FieldedDefinitionBase;
            if (e != null)
            {
                FieldBase x = e.Fields.FirstOrDefault(f => f.Guid.Equals(entry));
                if (x != null) return x;
            }

            CodeBlock c = element as CodeBlock;
            if (c != null)
            {
                FieldBase x = c.Inputs.FirstOrDefault(f => f.Guid.Equals(entry));
                if (x != null) return x;

                x = c.Outputs.FirstOrDefault(f => f.Guid.Equals(entry));
                if (x != null) return x;
            }

            return null;
        }
    }
}
