using Microsoft.VisualStudio.Modeling.Diagrams;

namespace BenjaminSchroeter.Flow.DataFlow
{
    partial class Connector
    {
        /// <summary>
        /// Modifies the luminosity of a highlighted connector.
        /// 
        /// The default formula of ModifyLuminosity is not appropriate for the color of this connector.
        /// </summary>
        /// <param name="currentLuminosity">The current luminosity.</param>
        /// <param name="view">The view.</param>
        /// <returns></returns>
        protected override int ModifyLuminosity(int currentLuminosity, DiagramClientView view)
        {
            if (!view.HighlightedShapes.Contains(new DiagramItem(this)))
                return currentLuminosity;

            return 130;
        }
    }
}
