using System.Linq;
using Microsoft.VisualStudio.Modeling;

namespace BenjaminSchroeter.Flow.DataFlow
{
    // the functions in this file control what other elements can be merged to one flow

    partial class TriggerFlow
    {
        private bool CanMergeMasterTrigger(ProtoElementBase element, ElementGroupPrototype prototype)
        {
            // The Master Trigger will be added on Model creation and can never be deleted.
            // No control can add the Master Trigger to the Model.

            // But on model creation time this method will be called, too.

            // allow only to add a Master Trigger if the model hasn't already one.
            return !this.FlowElements.Any(e => e is MasterTrigger);
        }
    }
}
