using Microsoft.VisualStudio.Modeling;

namespace BenjaminSchroeter.Flow.DataFlow
{
    /// <summary>
    /// This ElementNameProvider does not the work he should do!!!
    /// 
    /// It does not provide new names to the model elements. For
    /// some elements i want to use the same name for all elements
    /// but also have the property set as "Is Element Name".
    /// 
    /// Without the default implementation of SetUniqueName() no
    /// number will be added to the default name.
    /// </summary>
    class NonUniqueElementNameProvider : ElementNameProvider 
    {
        public override void SetUniqueName(ModelElement element, ModelElement container, DomainRoleInfo embeddedDomainRole, string baseName)
        {
            // empty !!! :-)
        }
    }
}
