using BenjaminSchroeter.Flow.DataFlow.Graphs;
using BenjaminSchroeter.Dsl.Graphs;
using Microsoft.VisualStudio.Modeling.Validation;

namespace BenjaminSchroeter.Flow.DataFlow
{
    [ValidationState(ValidationState.Enabled)]
    partial class FlowBase
    {
        [ValidationMethod(ValidationCategories.Menu | ValidationCategories.Save | ValidationCategories.Open)]
        private void ValidateNoCircle(ValidationContext context)
        {
            DataFlowGraph g = new DataFlowGraph(this);
            DepthFirstSearch<FlowElement, FlowElementReferencesTargetFlowElements> dfs = new DepthFirstSearch<FlowElement, FlowElementReferencesTargetFlowElements>(g);

            foreach (FlowElement circleComponent in dfs.Circles)
            {
                string msg = string.Format("Some Elements in the {0} are forming an illegal circle.", this.GetType().Name);
                context.LogError(msg, "FlowBase.ValidateNoCircle", circleComponent);
            }
        }
    }
}
