using Microsoft.VisualStudio.Modeling.Validation;

namespace BenjaminSchroeter.Flow.DataFlow
{
    partial class Output
    {
        [ValidationMethod(ValidationCategories.Menu | ValidationCategories.Save | ValidationCategories.Open)]
        private void ValidateMissingInputs(ValidationContext context)
        {
            int inputErrMsgCount = this.ValidateMissingInputsBase(context);

            // but at least one input should be present
            // even if all fields are optional
            //  and only if the code above hasn't generate any messages
            if (this.SourceFlowElements.Count == 0 && inputErrMsgCount == 0)
            {
                string msg = string.Format("The Output '{0}' must have at least one incomming connection.", this.Name);
                context.LogError(msg, "Output.ValidateMissingInputs", this);
            }

        }
    }
}
