using Microsoft.VisualStudio.Modeling.Validation;

namespace BenjaminSchroeter.Flow.DataFlow
{
    [ValidationState(ValidationState.Enabled)]
    partial class Variable
    {
        [ValidationMethod(ValidationCategories.Menu | ValidationCategories.Save | ValidationCategories.Open)]
        private void ValidateInputOutputCount(ValidationContext context)
        {
            if ( !this.Readable )
            {
                int outputs = this.TargetFlowElements.Count;
                if ( outputs > 0 )
                {
                    string msg = string.Format("The Variable '{0}' is not readable. You must not create any outgoing connections.", this.Name);
                    context.LogError(msg, "Variable.ValidateInputOutputCount", this);
                }
            }

            if (!this.Writable)
            {
                int inputs = this.SourceFlowElements.Count;
                if (inputs > 0)
                {
                    string msg = string.Format("The Variable '{0}' is not writable. You must not create any incoming connections.", this.Name);
                    context.LogError(msg, "Variable.ValidateInputOutputCount", this);
                }
            }
        }
    }
}
