using System;
using System.Collections.Generic;
using System.ComponentModel.Design;
using BenjaminSchroeter.Dsl.CompartmentMapping;
using Microsoft.VisualStudio.Modeling.Shell;

namespace BenjaminSchroeter.Flow.DataFlow
{
    partial class DataFlowCommandSet
    {
        protected override IList<MenuCommand> GetMenuCommands()
        {
            IList<MenuCommand> commands = base.GetMenuCommands();

            // remove some commands
            CompartmentMappingUtil.RemoveRerouteCommand(commands);
            CompartmentMappingUtil.RemoveCompartmentShapeExpandCollapseCommand(commands);

            // add some
            commands.Add(CreateOpenCodeBlockEditorCommand());

            return commands;
        }

        private DynamicStatusMenuCommand CreateOpenCodeBlockEditorCommand()
        {
            CommandID menuCommandID = new CommandID(OpenCodeBlockEditorCommandHandler.guidDataflow, (int)OpenCodeBlockEditorCommandHandler.cmdId);

            CodeBlockShape.ShapeDoubleClick += InvokeHandler;

            DynamicStatusMenuCommand menuItem = new DynamicStatusMenuCommand(
                delegate(object sender, EventArgs e) { OpenCodeBlockEditorCommandHandler.QueryStatus(sender, this.CurrentDocumentSelection, this.ServiceProvider); },
                InvokeHandler,
                menuCommandID);

            return menuItem;
        }

        private void InvokeHandler(object sender, EventArgs e)
        {
            OpenCodeBlockEditorCommandHandler.Invoke(this.CurrentDocumentSelection, this.CurrentDocData, this.ServiceProvider); 
        }
    }
}
