using System;

namespace BenjaminSchroeter.Flow.DataFlow
{
    partial class DataFlowCommandSet
    {
        // The Model has a "Validate" and a "Validate All" context menu entry.
        // The following overrids hide the "Validate All" always
        // but show the "Validate" entry.
        // 
        // It also switch the "Validate" and "Validate All" commands so that
        // the "Validate" command validates all elements of the model.

        internal override void OnStatusValidateModel(object sender, EventArgs e)
        {
            // always hide the "Validate All" commad
            System.ComponentModel.Design.MenuCommand cmd = sender as System.ComponentModel.Design.MenuCommand;
            cmd.Enabled = cmd.Visible = false;
        }
        internal override void OnMenuValidateModel(object sender, EventArgs e)
        {
            // no one will ever call this command - it is alwas hidden
            return;
        }

        internal override void OnMenuValidate(object sender, EventArgs e)
        {
            // this is the "validate" command
            if (this.CurrentDataFlowDocData != null)
                this.CurrentDataFlowDocData.ClearGlobalValidationErrorListItems();

            // but we call the "validate all" logic
            base.OnMenuValidateModel(sender, e);
        }

        internal override void OnStatusValidate(object sender, EventArgs e)
        {
            // this is the "validate" command (status)

            // but we call the "validate all" logic
            base.OnStatusValidateModel(sender, e);
        }
    }
}
