using System;
using System.Linq;

namespace BenjaminSchroeter.Flow.Datastructures.Data
{
    partial class DatastructureModelData
    {
        /// <summary>
        /// Finds the variable with a given GUID.
        /// </summary>
        /// <param name="guid">The GUID.</param>
        /// <returns></returns>
        public VariableData FindVariable(Guid guid)
        {
            return this.Variables.FirstOrDefault(x => x.Guid.Equals(guid));
        }

        /// <summary>
        /// Finds the record with a given GUID.
        /// </summary>
        /// <param name="guid">The GUID.</param>
        /// <returns></returns>
        public RecordData FindRecord(Guid guid)
        {
            return this.Records.FirstOrDefault(x => x.Guid.Equals(guid));
        }

        /// <summary>
        /// Finds the output event with a given GUID.
        /// </summary>
        /// <param name="guid">The GUID.</param>
        /// <returns></returns>
        public OutputEventData FindOutputEvent(Guid guid)
        {
            return this.OutputEvents.FirstOrDefault(x => x.Guid.Equals(guid));
        }

        /// <summary>
        /// Finds the function with a given GUID.
        /// </summary>
        /// <param name="guid">The GUID.</param>
        /// <returns></returns>
        public FunctionData FindFunction(Guid guid)
        {
            return this.Functions.FirstOrDefault(x => x.Guid.Equals(guid));
        }
    }
}
