using Microsoft.VisualStudio.Modeling;
using Microsoft.VisualStudio.Modeling.Diagrams;

namespace BenjaminSchroeter.Flow.Datastructures
{
    partial class DatastructuresDiagram
    {
        // must be implemented in a partial class of DatastructuresDiagram.  Given an instance of CommentConnector,
        // the method should return the source shape for the connector.  This method should not return null.
        private NodeShape GetTargetShapeForCommentConnector(CommentConnector connector)
        {
            return null;
        }

        // The following method needs to be added in a partial class
        private ModelElement GetTargetRolePlayerForLinkMappedByCommentConnector(CommentConnector connector)
        {
            CommentReferencesBaseDomainClasses reference = connector.ModelElement as CommentReferencesBaseDomainClasses;
            if (reference == null)
                return null;
            return reference.BaseDomainClass;
        }
    }
}

