﻿using System;
using System.Collections.ObjectModel;
using System.Linq;
using Microsoft.VisualStudio.Modeling;

namespace BenjaminSchroeter.Flow.Datastructures
{
    partial class ExternalVisibleDomainClass
    {
        protected override void MergeConfigure(Microsoft.VisualStudio.Modeling.ElementGroup elementGroup)
        {
            base.MergeConfigure(elementGroup);

            // find the highest InternalRecordId in the current model
            ReadOnlyCollection<ModelElement> elements1 = this.Partition.ElementDirectory.FindElements(ExternalVisibleDomainClass.DomainClassId);
            byte max1 = elements1.Max(x => (x as ExternalVisibleDomainClass).InternalRecordId );

            ReadOnlyCollection<ModelElement> elements2 = this.Partition.ElementDirectory.FindElements(Function.DomainClassId);
            byte max2 = 0;
            if (elements2.Count > 0)
                max2 = elements2.Max(x => (x as Function).InternalRecordIdForReturn);
            byte max = Math.Max(max1, max2);

            // but start at 128
            max = Math.Max(max, (byte) 127);            

            // and give this new Element a higher one
            this.InternalRecordId = ++max;

            Function f = this as Function;
            if (f != null)
                f.InternalRecordIdForReturn = (byte)(this.InternalRecordId + 1);
        }
    }
}
