using BenjaminSchroeter.Dsl.UserRestrictions;
using BenjaminSchroeter.Flow.HardwareDescription.Data;

namespace BenjaminSchroeter.Flow.Datastructures
{
    [CustomRestrictedProperty("StringLength")]
    partial class FieldBase : ISupportsUserRestrictions
    {
        /// <summary>
        /// Hides the "StringLength" property if a type != string is selected.
        /// </summary>
        public Restriction GetRestriction(string property)
        {
            // only for this property
            if (property != "StringLength")
                return Restriction.Full;

            // if type is missing hide it
            if (this.Type == null)
                return Restriction.Hidden;

            DslDataType dslType = this.Type.AsDslType(this.Store);
            return dslType == DslDataType.String ? Restriction.Full : Restriction.Hidden;
        }
    }
}
