using Microsoft.VisualStudio.Modeling.Validation;

namespace BenjaminSchroeter.Flow.Datastructures
{
    [ValidationState(ValidationState.Enabled)]
    partial class BaseDomainClass
    {
        [ValidationMethod(ValidationCategories.Menu | ValidationCategories.Save | ValidationCategories.Open)]
        private void ValidateName(ValidationContext context)
        {
            if ( this.Name.Trim() == "" )
            {
                string type = this.GetType().Name;
                string msg = string.Format("The name of a {0} must not be empty.", type);
                context.LogError(msg, "BaseDomainClass.ValidateName", this);
            }
        }
    }
}
