using BenjaminSchroeter.Dsl;
using Microsoft.VisualStudio.Modeling.Validation;

namespace BenjaminSchroeter.Flow.Datastructures
{
    [ValidationState(ValidationState.Enabled)]
    partial class Function
    {
        [ValidationMethod(ValidationCategories.Menu | ValidationCategories.Save | ValidationCategories.Open)]
        private void ValidateFields(ValidationContext context)
        {
            // the Parameter of the Function
            ValidationHelper.CheckNameUniqueness(context,
                            this.Parameters, 
                            "Function.ValidateFields",
                            x => x.Name);

            // the Return values of the Function
            ValidationHelper.CheckNameUniqueness(context,
                    this.ReturnValues,
                    "Function.ValidateFields",
                    x => x.Name);
        }

        [ValidationMethod(ValidationCategories.Menu | ValidationCategories.Save | ValidationCategories.Open)]
        private void ValidateInternalIds(ValidationContext context)
        {
            if ( this.InternalRecordId == this.InternalRecordIdForReturn )
            {
                string msg = string.Format("The two Internal RecordIds of the function '{0}' must not be the same.", this.Name);
                context.LogError(msg, "Function.ValidateInternalIds", this);
            }

        }
    }
}
