using BenjaminSchroeter.Dsl;
using Microsoft.VisualStudio.Modeling.Validation;

namespace BenjaminSchroeter.Flow.Datastructures
{
    [ValidationState(ValidationState.Enabled)]
    partial class Record
    {
        [ValidationMethod(ValidationCategories.Menu | ValidationCategories.Save | ValidationCategories.Open)]
        private void ValidateFieldCount(ValidationContext context)
        {
            if (this.Fields.Count == 0)
            {
                string msg = string.Format("The record '{0}' must contain at least one field.", this.Name);
                context.LogError(msg, "Record.ValidateFieldCount", this);
            }
        }

        [ValidationMethod(ValidationCategories.Menu | ValidationCategories.Save | ValidationCategories.Open)]
        private void ValidateFields(ValidationContext context)
        {
            ValidationHelper.CheckNameUniqueness(context,
                            this.Fields,
                            "Record.ValidateFields",
                            x => x.Name);
        }
    }
}
