using System;
using System.ComponentModel.Design;
using BenjaminSchroeter.Flow.Datastructures.DataService;
using BenjaminSchroeter.Dsl.UserRestrictions;
using Microsoft.VisualStudio.Shell;

namespace BenjaminSchroeter.Flow.Datastructures
{
    // services
    [ProvideService(typeof(SDatastructureDataService))]

    // package load key
    [ProvideLoadKey("Standard", "1.0", "Flow Datastructures", "Benjamin Schroeter", 200)]
    partial class DatastructuresPackage
    {
        public DatastructuresPackage(): base()
        {
            IServiceContainer serviceContainer = this;

            // register services
            serviceContainer.AddService(typeof(SDatastructureDataService), createDataService, true);
        }

        /// <summary>
        /// Creates the SDatastructureDataService.
        /// </summary>
        /// <param name="container">The container.</param>
        /// <param name="serviceType">Type of the service.</param>
        /// <returns></returns>
        private object createDataService(IServiceContainer container, Type serviceType)
        {
            if ( container != this )
                return null;

            if (serviceType == typeof(SDatastructureDataService))
                return new DatastructureDataService(this);

            return null;
        }

        protected override void Initialize()
        {
            base.Initialize();

            // Restricted Properties. Used by the record field (string length)
            UserRestrictionProvider.RegisterAllRestrictedElements<DatastructuresDiagram>();
        }
    }
}
