/** \file
	@version{1.0}
	@productname{MSB}
	@vendorname{Benjamin Schroeter}
	@producturl{http://www.irgendwie.net}
	@vendorurl{http://www.irgendwie.net/msb}
	@firmwarename{msb360 v2}
	@description{my great firmware for the msb360 ;) ...}*/

// ------------------------------------------------------------------------------------

/// @output{Serial Output}
/// @description{Output to serial 1}
/// @param Text @field{Text} @description{This text will bis send}
void SetSerial(string Text) {}

/// @outputInit{Serial Output}
/// @description{Output to serial 1}
/// @param speed @parameter{Speed (baud)} @default{9600} @description{some more bla bla}
/// @param DataBits @parameter{Data bits} @default{8}
/// @param StopBits @parameter{Stop bits} @default{1}
void InitSerial(int speed, byte DataBits, byte StopBits) {}

// ------------------------------------------------------------------------------------

/// @output{Serial Output 2nd version}
/// @description{Output to serial 1 with other parameter documentation}
/// @param Text @field{Text} @description{This text will bis send} @optional
void SetSerial2(string Text) {}

/// @outputInit{Serial Output 2nd version}
void InitSerial2(int speed /** @parameter{Speed (baud)} @default{9600} */,
                byte DataBits /** @parameter{Data bits} @default{8} */,
                byte StopBits /** @parameter{Stop bits} @default{1}*/) {}

// ------------------------------------------------------------------------------------

/// @getVariable{$NODE_ID}
/// @description{The ID of the current Node}
bool GetNodeId(int* id) {}

/// @setVariable{$NODE_ID}
bool SetNodeId(int id) {}

// ------------------------------------------------------------------------------------

/// @input{Analog Input}
/// @description{the build in a/d converter}
/// @param ad1 @field{A/D Port 1}
/// @param ad2 @field{A/D Port 2}
void GetADInput(int* ad1, int* ad2) {}

/// @inputInit{Analog Input}
/// @param umax @parameter{U max} @default{5}
/// @param fastMode @parameter{fast measuring mode} @default{true}
/// @param adEnabled @enabled
/// @param ad1enabled @fieldenabled{A/D Port 1}
/// @param ad2enabled @fieldenabled{A/D Port 2}
void InitADInput(int umax, bool fastMode, bool adEnabled, bool ad1enabled, bool ad2enabled) {}

// ------------------------------------------------------------------------------------

/// @event{Sound detected}
/// @description{using the microphone}
/// @isSingleton
/// @param minFreq @parameter{min frequency}
/// @param maxFreq @parameter{max frequency}
/// @param threshold @parameter{threshold}
/// @param callback
void RegisterSoundDetectedCallback(int minFreq, int maxFreq, int threshold, void* callback) {}

/// @eventCallback{Sound detected}
/// @param volume @field{Volume}
/// @param duration @field{Duration} @description{im ms}
void EventHandler(int volume, int duration) {}

// ------------------------------------------------------------------------------------
/// @input{Digital In}
/// @description{some other port}
/// @param p1 @field{Port 1}
/// @param p2 @field{Port 2}
/// @param p3 @field{Port 3}
/// @param p4 @field{Port 4}
bool GetDigitalIn(bool* p1, bool* p2, bool* p3, bool* p4) {}

// ------------------------------------------------------------------------------------

/// @output{Digital I/O}
/// @field{Port 1}
/// @description{Pin 12 of MSB}
void SetDigital1(bool value) {}

/// @output{Digital I/O}
/// @field{Port 2}
/// @optional
void SetDigital2(bool value) {}

/// @output{Digital I/O}
/// @field{Port 3}
/// @optional
void SetDigital3(bool value) {}

/// @output{Digital I/O}
/// @field{Port 4}
void SetDigital4(bool value) {}

/// @outputInit{Digital I/O}
/// @description{descrition for the whole Output Port}
/// @param p1Enabled @fieldenabled{Port 1}
/// @param p2Enabled @fieldenabled{Port 2}
/// @param p3Enabled @fieldenabled{Port 3}
/// @param p4Enabled @fieldenabled{Port 4}
/// @param shapeEnabeld @enabled
void InitDigitalIO(bool p1Enabled, bool p2Enabled, bool p3Enabled, bool p4Enabled, bool shapeEnabeld) {}


// ---------------------------------------------------------------------
/// @output{Analog out}
/// @field{Port 1}
/// @description{Pin 12 of MSB}
void SetAnalog1(int value) {}

/// @output{Analog out}
/// @field{Port 2}
/// @optional
void SetAnalog2(int value) {}

/// @output{Analog out}
/// @field{Port 3}
/// @optional
void SetAnalog3(int value) {}

/// @output{Analog out}
/// @field{Port 4}
void SetAnalog4(int value) {}
