using System.Collections.Generic;
using System.Linq;

namespace BenjaminSchroeter.Flow.Firmwareparser.SemanticChecks
{
    /// <summary>
    /// Semantic Check Rule to ensure that the @multiplicity
    /// annotation is only used for events.
    /// </summary>
    class Chk006 : SemanticCheckBase
    {
        public Chk006(IList<ParsingMessage> messages) : base(messages)    {}

        public override void Check(CodeDescription doc)
        {
            IEnumerable<function> x = from f in doc.function
                                      where f.multiplicitySpecified && f.ItemElementName != ItemChoiceType.@event 
                                       select f;

            foreach (function f in x)
                ReportError("006", "@multiplicity is only valid for an @event function, not for {0}().", f.name);
        }
    }
}
