using System;
using System.Linq;
using System.Windows.Forms;
using System.Xml.Linq;
using BenjaminSchroeter.Flow.Firmwareparser;

namespace BenjaminSchroeter.Flow.FirmwareparserStandAloneGui
{
    public partial class Form1 : Form
    {
        XDocument doc;

        public Form1()
        {
            InitializeComponent();
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            this.listView1.Items.Clear();
            
            using (FirmwareParser p = new FirmwareParser())
            {
                p.OutputDirectory = this.textOutputDirectory.Text;
                p.DoxygenExecutable = this.textDoxyGenExe.Text;

                p.Parse(this.listBoxInputFiles.Items.Cast<string>().ToArray());
                doc = p.GetXDocument();

                foreach (ParsingMessage message in p.Messages)
                {
                    ListViewItem lvi =
                        new ListViewItem(new[]
                                             {
                                                 message.Priority.ToString(), message.Text, message.File,
                                                 message.Line.ToString(),message.ErrorKey
                                             });
                    this.listView1.Items.Add(lvi);
                }
            }
        }

        #region open xxx dialoge
        private void btnSelectOutput_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog d = new FolderBrowserDialog();
            if (d.ShowDialog(this) == System.Windows.Forms.DialogResult.OK)
                this.textOutputDirectory.Text = d.SelectedPath;
        }

        private void btnSelectDoygenExe_Click(object sender, EventArgs e)
        {
            OpenFileDialog d = new OpenFileDialog();
            d.Filter = "*.exe|*.exe|*.*|*.*";
            if (d.ShowDialog(this) == System.Windows.Forms.DialogResult.OK)
                this.textDoxyGenExe.Text = d.FileName;            
        }

        private void btnAddInput_Click(object sender, EventArgs e)
        {
            OpenFileDialog d = new OpenFileDialog();
            d.Filter = "*.h|*.h|*.c|*.c|*.*|*.*";
            d.Multiselect = true;
            if (d.ShowDialog(this) == System.Windows.Forms.DialogResult.OK)
                foreach (string s in d.FileNames)
                    this.listBoxInputFiles.Items.Add(s);
        }
        #endregion

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.Save();
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            this.listBoxInputFiles.Items.Clear();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.listBoxInputFiles.Items.Add(@"D:\da\MainCode\HardwareDescription\Firmwareparser\Ressources\errTest.c");
            this.btnStart_Click(sender,e);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (doc == null)
                return;

            XDocDisplayForm f = new XDocDisplayForm();
            f.ShowXDoc(doc);
            f.Show(this);
        }

    }
}