using System;
using System.Windows.Forms;
using System.Xml.Linq;

namespace BenjaminSchroeter.Flow.FirmwareparserStandAloneGui
{
    public partial class XDocDisplayForm : Form
    {
        private XDocument doc;

        public XDocDisplayForm()
        {
            InitializeComponent();
        }

        public void ShowXDoc(XDocument d)
        {
            this.doc = d;

            this.treeView1.BeginUpdate();
            this.treeView1.Nodes.Add(CreateElement(doc.Root));
            this.treeView1.ExpandAll();
            this.treeView1.EndUpdate();
        }

        private TreeNode CreateElement(XElement element)
        {
            TreeNode n = new TreeNode();
            n.Text = element.Name.LocalName;
            string value = element.Value.Trim();
            if (value.Length > 0 && !element.HasElements)
                n.Nodes.Add("~" + value + "~");

            foreach (XAttribute attribute in element.Attributes())
            {
                if (attribute.Name.Namespace == "")
                {
                    TreeNode na = new TreeNode();
                    na.Text = attribute.Name + " = " + attribute.Value;
                    n.Nodes.Add(na);
                }
            }
            foreach (XElement e2 in element.Elements())
            {
                n.Nodes.Add(CreateElement(e2));
            }

            return n;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SaveFileDialog d = new SaveFileDialog();
            d.Filter = "*.xml|*.xml|*.*|*.*";
            if ( d.ShowDialog(this) == System.Windows.Forms.DialogResult.OK )
                doc.Save(d.FileName);
        }
    }
}
