using System.Runtime.InteropServices;
using BenjaminSchroeter.Flow.HardwareDescription.Data;
using Microsoft.VisualStudio.Shell.Interop;

namespace BenjaminSchroeter.Flow.HardwareDescription.DataService
{
    /// <summary>
    /// DataService to receive the Hardwaredescription of a given project.
    /// </summary>
    [Guid("975E39A6-B542-4aef-834C-C530AE3C0C1B")]
    [ComVisible(true)]
    public interface IHardwareDescriptionDataService
    {
        /// <summary>
        /// Gets the hardware description from the given project
        /// </summary>
        /// <exception cref="WrongNumberOfHardwareDescriptionException">There are none or more than one Hardware Descriptions in the project</exception>
        /// <param name="projectHierarchy">The project hierarchy item.</param>
        /// <returns></returns>
        HardwareDescriptionModelData GetHardwareDescription(IVsHierarchy projectHierarchy);
    }
}
