using Microsoft.VisualStudio.Modeling;
using Microsoft.VisualStudio.Modeling.Diagrams;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    partial class HardwareDescriptionDiagram
    {
        // must be implemented in a partial class of HardwareDescriptionDiagram.  Given an instance of CommentConnector,
        // the method should return the source shape for the connector.  This method should not return null.
        private NodeShape GetTargetShapeForCommentConnector(CommentConnector connector)
        {
            return null;
        }

        // The following method needs to be added in a partial class
        private ModelElement GetTargetRolePlayerForLinkMappedByCommentConnector(CommentConnector connector)
        {
            CommentReferencesEnableableDomainClasses reference = connector.ModelElement as CommentReferencesEnableableDomainClasses;
            if (reference == null)
                return null;
            return reference.EnableableDomainClass;
        }
    }
}

