using Microsoft.VisualStudio.Modeling;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    /// <summary>
    /// When a new DataType is added to the model: inform the DataTypeConverter.
    /// </summary>
    /// <remarks>
    /// The DataTypeConverter is used to show the dropdown list for the type field 
    /// in the properties window.
    /// </remarks>
    [RuleOn(typeof(DataType), FireTime = TimeToFire.LocalCommit)]
    class DataTypeAddRule : AddRule
    {
        public override void ElementAdded(ElementAddedEventArgs e)
        {
            DataType t = e.ModelElement as DataType;
            if ( t != null )
                DataTypes.DataTypeConverter.AddDataType(e.ModelElement.Store, t.Name,t.CType,t.DslType );
        }
    }
}
