using Microsoft.VisualStudio.Modeling;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    /// <summary>
    /// When a new DataType is deleted from the model: inform the DataTypeConverter.
    /// </summary>
    /// <remarks>
    /// The DataTypeConverter is used to show the dropdown list for the type field 
    /// in the properties window.
    /// </remarks>
    [RuleOn(typeof(DataType), FireTime = TimeToFire.LocalCommit)]
    class DataTypeDeleteRule : DeleteRule
    {
        public override void ElementDeleted(ElementDeletedEventArgs e)
        {
            DataType t = e.ModelElement as DataType;
            if (t != null)
                DataTypes.DataTypeConverter.RemoveDataType(e.ModelElement.Store, t.Name );
        }
    }
}