using System;
using System.Collections.ObjectModel;
using BenjaminSchroeter.Dsl.CompartmentMapping;
using Microsoft.VisualStudio.Modeling;
using Microsoft.VisualStudio.Modeling.Diagrams.GraphObject;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
	#region Code for ConnectionBuilder 'EnableableRelationship'
    public partial class SourceOrTargetOfEnableableRelationshipDeletingRule : CompartmentEntryDeletingRuleBase<EnableableShapeMappedDomainClass, ModelElement, EnableableRelationship, EnableableShapeMappedDomainClass, ModelElement>
    {
        protected override CompartmentMappingBuilderBase<EnableableShapeMappedDomainClass, ModelElement, EnableableRelationship, EnableableShapeMappedDomainClass, ModelElement> GetBuilderInstance()
        {
            return EnableableRelationshipBuilder.builder;
        }
    }

    public class EnableableRelationshipRouter : CompartmentMappingRouterBase<EnableableShapeMappedDomainClass, ModelElement, EnableableRelationship, EnableableShapeMappedDomainClass, ModelElement>
    {
        protected override CompartmentMappingBuilderBase<EnableableShapeMappedDomainClass, ModelElement, EnableableRelationship, EnableableShapeMappedDomainClass, ModelElement> GetBuilderInstance()
        {
            return EnableableRelationshipBuilder.builder;
        }
    }

    public partial class EnableableRelationshipBuilder
    {
        internal static readonly EnableableRelationshipBuilderInstance builder = new EnableableRelationshipBuilderInstance();

        public static bool CanAcceptSource(ModelElement candidate)
        {
            return builder.CanAcceptSource(candidate);
        }

        public static bool CanAcceptTarget(ModelElement candidate)
        {
            return builder.CanAcceptTarget(candidate);
        }

        public static bool CanAcceptSourceAndTarget(ModelElement candidateSource, ModelElement candidateTarget)
        {
            return builder.CanAcceptSourceAndTarget(candidateSource, candidateTarget);
        }

        public static ElementLink Connect(ModelElement source, ModelElement target)
        {
            return builder.Connect(source, target);
        }
    }

	// Create this partial class in another file and implement at least the abstract methods!
    public partial class EnableableRelationshipBuilderInstance : CompartmentMappingBuilderBase<EnableableShapeMappedDomainClass, ModelElement, EnableableRelationship, EnableableShapeMappedDomainClass, ModelElement>
    {
        internal EnableableRelationshipBuilderInstance()
            : base(
                true,		/* connection.Source.AllowHead */
                true,		/* connection.Target.AllowHead */
                false,	/* connection.AllowSelfReference */	
                false		/* connection.AllowsDuplicates */	)
        {
        }
        
        /// <summary>
        /// Gets all links for the Connection used by this ConnectionBuilderInstance.
        /// </summary>
        /// <remarks>Only a static method of the connection instance can get ths links</remarks>
        /// <param name="source">The source.</param>
        /// <param name="target">The target.</param>
        /// <returns></returns>
		protected override ReadOnlyCollection<EnableableRelationship> GetLinks(EnableableShapeMappedDomainClass source, EnableableShapeMappedDomainClass target)
        {
			// delegates this call to the static method of the connection class (EnableableRelationship)
            return EnableableRelationship.GetLinks(source, target);
        }
    }	
	#endregion

	#region Code for CompartmentShape 'InputShape'
    partial class InputShape : ICompartmentMouseActionTrackable
    {
        private readonly CompartmentMouseTrack mouseTrack = new CompartmentMouseTrack();

        public CompartmentMouseTrack MouseTrack
        {
            get { return mouseTrack; }
        }

        public override void OnShapeInserted()
        {
            mouseTrack.ShapeInserted(this);
            base.OnShapeInserted();
        }
        
        public override void OnAbsoluteBoundsChanged(Microsoft.VisualStudio.Modeling.Diagrams.AbsoluteBoundsChangedEventArgs e)
        {
            CompartmentMappingUtil.RerouteCompartmentMappings(this);
            base.OnAbsoluteBoundsChanged(e);
        }
    }
	#endregion
	#region Code for CompartmentShape 'OutputShape'
    partial class OutputShape : ICompartmentMouseActionTrackable
    {
        private readonly CompartmentMouseTrack mouseTrack = new CompartmentMouseTrack();

        public CompartmentMouseTrack MouseTrack
        {
            get { return mouseTrack; }
        }

        public override void OnShapeInserted()
        {
            mouseTrack.ShapeInserted(this);
            base.OnShapeInserted();
        }
        
        public override void OnAbsoluteBoundsChanged(Microsoft.VisualStudio.Modeling.Diagrams.AbsoluteBoundsChangedEventArgs e)
        {
            CompartmentMappingUtil.RerouteCompartmentMappings(this);
            base.OnAbsoluteBoundsChanged(e);
        }
    }
	#endregion
	#region Code for CompartmentShape 'EventShape'
    partial class EventShape : ICompartmentMouseActionTrackable
    {
        private readonly CompartmentMouseTrack mouseTrack = new CompartmentMouseTrack();

        public CompartmentMouseTrack MouseTrack
        {
            get { return mouseTrack; }
        }

        public override void OnShapeInserted()
        {
            mouseTrack.ShapeInserted(this);
            base.OnShapeInserted();
        }
        
        public override void OnAbsoluteBoundsChanged(Microsoft.VisualStudio.Modeling.Diagrams.AbsoluteBoundsChangedEventArgs e)
        {
            CompartmentMappingUtil.RerouteCompartmentMappings(this);
            base.OnAbsoluteBoundsChanged(e);
        }
    }
	#endregion

	#region Code for Shape 'VariableShape'
    partial class VariableShape
    {
        public override void OnAbsoluteBoundsChanged(Microsoft.VisualStudio.Modeling.Diagrams.AbsoluteBoundsChangedEventArgs e)
        {
            CompartmentMappingUtil.RerouteCompartmentMappings(this);
            base.OnAbsoluteBoundsChanged(e);
        }
    }
	#endregion

	#region Code for Connector 'EnableableRelationshipConnector'
    partial class EnableableRelationshipConnector
    {
        public override void OnInitialize()
        {
            this.FixedFrom = VGFixedCode.Caller;
            this.FixedTo = VGFixedCode.Caller;
            base.OnInitialize();
        }

        public override bool CanManuallyRoute
        {
            get
            {
                return false;
            }
        }
    }
    
    [RuleOn(typeof(EnableableRelationshipConnector), FireTime = TimeToFire.LocalCommit)]
    public class EnableableRelationshipConnectorAddRule : CompartmentMappingAddRuleBase
    {
    }
	#endregion
}
