using Microsoft.VisualStudio.Modeling;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    /// <summary>
    /// This rule is needed by the CompartmentMapping to remove Links
    /// and Connectors if someone deletes a Field.
    /// 
    /// If the whole shape is deleted the DSL Tools handel the deletion
    /// of the links for us.
    /// </summary>
    [RuleOn(typeof(InputField), FireTime = TimeToFire.LocalCommit)]
    [RuleOn(typeof(OutputField), FireTime = TimeToFire.LocalCommit)]
    [RuleOn(typeof(EventField), FireTime = TimeToFire.LocalCommit)]
    partial class SourceOrTargetOfEnableableRelationshipDeletingRule
    {

    }
}
