using System.Text;
using Microsoft.VisualStudio.Modeling;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    partial class HardwareDescriptionSerializationHelper
    {
        public override void SaveModel(SerializationResult serializationResult, HardwareDescriptionModel modelRoot, string fileName, Encoding encoding, bool writeOptionalPropertiesWithDefaultValue)
        {
            IncVersion(modelRoot);

            base.SaveModel(serializationResult, modelRoot, fileName, encoding, writeOptionalPropertiesWithDefaultValue);
        }

        public override void SaveModelAndDiagram(SerializationResult serializationResult, HardwareDescriptionModel modelRoot, string modelFileName, HardwareDescriptionDiagram diagram, string diagramFileName, Encoding encoding, bool writeOptionalPropertiesWithDefaultValue)
        {
            IncVersion(modelRoot);

            base.SaveModelAndDiagram(serializationResult, modelRoot, modelFileName, diagram, diagramFileName, encoding, writeOptionalPropertiesWithDefaultValue);
        }

        /// <summary>
        /// Increase the version of the model.
        /// </summary>
        /// <remarks>
        /// Will be called every time the model is saved (see above).
        /// </remarks>
        /// <param name="modelRoot">The model.</param>
        private void IncVersion(HardwareDescriptionModel modelRoot)
        {
            using (Transaction t = modelRoot.Store.TransactionManager.BeginTransaction("change version"))
            {
                // handle the overflow
                if (modelRoot.Version < int.MaxValue)
                    modelRoot.Version++;
                else
                    modelRoot.Version = 1;

                t.Commit();
            }
        }
    }
}
