﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.Modeling;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    [RuleOn(typeof(OutputField), FireTime = TimeToFire.LocalCommit)]
    class OutputFieldOptionalChanged : ChangeRule
    {
        public override void ElementPropertyChanged(ElementPropertyChangedEventArgs e)
        {
            if ( e.DomainProperty.Id == OutputField.EnabledDomainPropertyId)
            {
                if (((bool)e.NewValue) == false && !(e.ModelElement as OutputField).Optional)
                    throw new Exception("You cannot disable a non optional field!");
            }
        }
    }
}
