using BenjaminSchroeter.Dsl.UserRestrictions;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    // This file controles the Visiblity and Writablility of all Properties 
    // using the RestrictedProperty attributes.
    [RestrictedProperty((int)RestrictionMode.Hardware, "UserDescription", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.Driver, "UserDescription", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.Hardware, "AppName", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.Driver, "AppName", Restriction.Hidden)]

    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Name", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "UserDescription", Restriction.Full)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "VendorName", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "ProductName", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Description", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Version", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "VendorUrl", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "ProductUrl", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "HeaderFile", Restriction.ReadOnly)]

    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Name", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "UserDescription", Restriction.Full)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "FirmwareName", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "VendorName", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "ProductName", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Description", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Version", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "VendorUrl", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "ProductUrl", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "HeaderFile", Restriction.ReadOnly)]
    partial class Platform { }


    [RestrictedProperty((int)RestrictionMode.Hardware, "CompatibilityInfo", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "CompatibilityInfo", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "CompatibilityInfo", Restriction.Hidden)]
    partial class DriverPlatform { }

    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "CallGetter", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "CallSetter", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Type", Restriction.ReadOnly)]

    [RestrictedProperty((int)RestrictionMode.DriverInfo, "CallGetter", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "CallSetter", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Type", Restriction.ReadOnly)]
    partial class Variable { }

    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "InitCall", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "InitCall", Restriction.Hidden)]
    partial class Port { }

    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Call", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Call", Restriction.Hidden)]
    partial class Input { }

    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Call", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Call", Restriction.Hidden)]
    partial class Output { }

    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Optional", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Optional", Restriction.ReadOnly)]
    partial class OutputField { }

    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Multiplicity", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Multiplicity", Restriction.ReadOnly)]
    partial class Event { }

    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Call", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Type", Restriction.ReadOnly)]

    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Call", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Type", Restriction.ReadOnly)]
    partial class EnableableFieldBase { }

    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Call", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Type", Restriction.ReadOnly)]

    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Call", Restriction.Hidden)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Type", Restriction.ReadOnly)]
    partial class FieldBase { }

    [RestrictedProperty((int)RestrictionMode.DriverInfo, "Name", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "CType", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.DriverInfo, "DslType", Restriction.ReadOnly)]

    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "Name", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "CType", Restriction.ReadOnly)]
    [RestrictedProperty((int)RestrictionMode.HardwareInfo, "DslType", Restriction.ReadOnly)]
    partial class DataType { }
}
