namespace BenjaminSchroeter.Flow.HardwareDescription
{
    /// <summary>
    /// The RestrictionModes used for the HardwareDescription Dsl Editor.
    /// </summary>
    /// <remarks>
    /// These modes control the visibility of properties.
    /// Allow the user to add and delete elements and hide elements from the toolbox.
    /// </remarks>
    public enum RestrictionMode
    {
        /// <summary>
        /// The default mode. The Editor behaves as moddeld in the DSL model
        /// </summary>
        Original = 0,
        /// <summary>
        /// a .hardware file is opened
        /// </summary>
        Hardware,
        /// <summary>
        /// a .hardwareinfo file is opened
        /// </summary>
        HardwareInfo,
        /// <summary>
        /// a .driver file is opened
        /// </summary>
        Driver,
        /// <summary>
        /// a .driverinfo file is opened
        /// </summary>
        DriverInfo
    }
}