using BenjaminSchroeter.Dsl.UserRestrictions;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    // Defines the Items of the Toolbox that should be hidden in some Restriction Modes
    //
    // All items, but comment shape / connector, will be removed if a .hardwareinfo, .driverinfo file is opened

    [RestrictToolboxItemUsing((int)RestrictionMode.HardwareInfo, "InputToolboxItem", "HardwareDescriptionToolboxTab")]
    [RestrictToolboxItemUsing((int)RestrictionMode.HardwareInfo, "OutputToolboxItem", "HardwareDescriptionToolboxTab")]
    [RestrictToolboxItemUsing((int)RestrictionMode.HardwareInfo, "EventToolboxItem", "HardwareDescriptionToolboxTab")]
    [RestrictToolboxItemUsing((int)RestrictionMode.HardwareInfo, "VariableToolboxItem", "HardwareDescriptionToolboxTab")]
    [RestrictToolboxItemUsing((int)RestrictionMode.HardwareInfo, "EnableableRelationshipToolboxItem", "HardwareDescriptionToolboxTab")]

    [RestrictToolboxItemUsing((int)RestrictionMode.DriverInfo, "InputToolboxItem", "HardwareDescriptionToolboxTab")]
    [RestrictToolboxItemUsing((int)RestrictionMode.DriverInfo, "OutputToolboxItem", "HardwareDescriptionToolboxTab")]
    [RestrictToolboxItemUsing((int)RestrictionMode.DriverInfo, "EventToolboxItem", "HardwareDescriptionToolboxTab")]
    [RestrictToolboxItemUsing((int)RestrictionMode.DriverInfo, "VariableToolboxItem", "HardwareDescriptionToolboxTab")]
    [RestrictToolboxItemUsing((int)RestrictionMode.DriverInfo, "EnableableRelationshipToolboxItem", "HardwareDescriptionToolboxTab")]
    partial class HardwareDescriptionDiagram { }
}
