using Microsoft.VisualStudio.Modeling.Validation;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    [ValidationState(ValidationState.Enabled)]
    partial class DataType
    {
        [ValidationMethod(ValidationCategories.Menu | ValidationCategories.Save | ValidationCategories.Open)]
        private void ValidateName(ValidationContext context)
        {
            if (this.Name.Trim() == "")
            {
                string msg = "The name of a DataType must not be empty.";
                context.LogError(msg, "DataType.ValidateName", this);
            }
        }

        [ValidationMethod(ValidationCategories.Menu | ValidationCategories.Save | ValidationCategories.Open)]
        private void ValidateCType(ValidationContext context)
        {
            if (this.CType.Trim() == "")
            {
                string msg = "The C Type of a DataType must not be empty.";
                context.LogError(msg, "DataType.ValidateCType", this);
            }
        }
    }
}
