using Microsoft.VisualStudio.Modeling.Validation;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    [ValidationState(ValidationState.Enabled)]
    partial class EventField
    {
        [ValidationMethod(ValidationCategories.Menu | ValidationCategories.Save | ValidationCategories.Open)]
        private void ValidateCall(ValidationContext context)
        {
            CallParameter c = this.CallParameter;

            if (c.HasFunction || c.HasEnabledParameter || !c.HasParameter)
            {
                string msg = string.Format("The Call Property of Parameter '{0}' of '{1}' is invalid. You must provide only the position in the parameter list.", this.Name, this.Event.Name);
                context.LogError(msg, "EventField.ValidateCall", this);
            }
        }
    }
}
