using Microsoft.VisualStudio.Modeling.Validation;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    [ValidationState(ValidationState.Enabled)]
    partial class OutputField
    {
        [ValidationMethod(ValidationCategories.Menu | ValidationCategories.Save | ValidationCategories.Open)]
        private void ValidateOptional(ValidationContext context)
        {
            if ( this.Optional && !this.CallParameter.HasFunction)
            {
                string msg = string.Format("The Field '{0}' of Output '{1}' must not be Optional since no Function Call is defined in the Call Property.", this.Name, this.Output.Name);
                context.LogError(msg, "OutputField.ValidateOptional", this);
            }
        }
    }
}
