using BenjaminSchroeter.Flow.UiSupportPackage;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    partial class HardwareDescriptionDocData
    {
        // in certain situations there are a few entries from a global validation
        // run in the error list. They will be cleared here since the local model 
        // validation will create these entries again. 
        // To avoid duplicates in the list.

        protected override bool CanSave(bool allowUserInterface)
        {
            ClearGlobalValidationErrorListItems();

            return base.CanSave(allowUserInterface);
        }

        protected override void OnDocumentLoaded()
        {
            ClearGlobalValidationErrorListItems();
            
            base.OnDocumentLoaded();
        }

        public override void ClearErrorListItems()
        {
            base.ClearErrorListItems();
            this.ValidationController.ClearMessages();
        }

        internal void ClearGlobalValidationErrorListItems()
        {
            if (string.IsNullOrEmpty(this.FileName) || this.Hierarchy == null)
                return;

            IGlobalValidation v = this.ServiceProvider.GetService(typeof (SGlobalValidation)) as IGlobalValidation;
            if ( v != null)
                v.ClearErrorListItems(this.FileName, this.Hierarchy);
        }
    }
}


