using System;
using BenjaminSchroeter.Dsl.UserRestrictions;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    partial class HardwareDescriptionDocData
    {
        protected override void Load(string fileName, bool isReload)
        {
            // after loading the file, set the restriction mode base on the filename
            SetRestrictionMode(fileName);

            base.Load(fileName, isReload);
        }

        /// <summary>
        /// Sets the restriction mode for the model if this DocData based on its fileextension
        /// </summary>
        /// <param name="fileName">Name of the file.</param>
        private void SetRestrictionMode(string fileName)
        {
            RestrictionMode mode;
            if (fileName.EndsWith(Constants.DesignerFileExtensionHardwareDescription, StringComparison.InvariantCultureIgnoreCase))
                mode = RestrictionMode.Hardware;
            else if (fileName.EndsWith(Constants.DesignerFileExtensionHardwareInfo, StringComparison.InvariantCultureIgnoreCase))
                mode = RestrictionMode.HardwareInfo;
            else if (fileName.EndsWith(Constants.DesignerFileExtensionDriverDescription, StringComparison.InvariantCultureIgnoreCase))
                mode = RestrictionMode.Driver;
            else if (fileName.EndsWith(Constants.DesignerFileExtensionDriverInfo, StringComparison.InvariantCultureIgnoreCase))
                mode = RestrictionMode.DriverInfo;
            else
                mode = RestrictionMode.Original;

            UserRestrictionProvider.SetRestrictionMode(this.Store,(int) mode);
        }
    }
}