using System.ComponentModel.Design;
using BenjaminSchroeter.DslTools;
using Microsoft.VisualStudio.Modeling.Shell;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    partial class HardwareDescriptionExplorer
    {
        protected override void ProcessOnStatusDeleteCommand(MenuCommand cmd)
        {
            // the delete commands logic is redirected 
            // to allow the user restrictions via attributes in the model element classes
            OnStatusDeleteCommandLogic.ForExplorerDelete(cmd,
                          this.SelectedElement,
                          base.ProcessOnStatusDeleteCommand);
        }

        protected override void ProcessOnStatusDeleteAllCommand(MenuCommand cmd)
        {
            // the delete commands logic is redirected 
            // to allow the user restrictions via attributes in the model element classes
            OnStatusDeleteCommandLogic.ForExplorerDeleteAll(cmd,
                         this.ObjectModelBrowser.SelectedNode,
                         base.ProcessOnStatusDeleteAllCommand);
        }

        public override void AddCommandHandlers(IMenuCommandService menuCommandService)
        {
            base.AddCommandHandlers(menuCommandService);

            // sometimes the ProcessOnStatusDeleteAllCommand is not called from the model explorer
            // adding this event handler is a good workaround for that problem
            MenuCommand deleteAllCommand = menuCommandService.FindCommand(CommonModelingCommands.ModelExplorerDeleteAll);
            this.ObjectModelBrowser.AfterSelect += delegate { ProcessOnStatusDeleteAllCommand(deleteAllCommand); };
        }
    }
}
