using System.Runtime.InteropServices;
using Microsoft.VisualStudio.Shell.Interop;

namespace BenjaminSchroeter.Flow.UiSupportPackage
{
    /// <summary>
    /// The Global Validation Service
    /// 
    /// Validates the whole project structure of a Scatter Web DSL project 
    /// and also every single dsl file
    /// </summary>
    [Guid("DE1E396F-D4BE-4CC9-82FF-EA37F92429FC")]
    [ComVisible(true)]
    public interface IGlobalValidation
    {
        /// <summary>
        /// Does the Validation.
        /// </summary>
        /// <returns>The number of found errors.</returns>
        int Validate();

        /// <summary>
        /// Clears the error list from all items corresponding to the given filename hand hierarchy item.
        /// </summary>
        /// <param name="filename">The filename.</param>
        /// <param name="hierarchy">The hierarchy item.</param>
        void ClearErrorListItems(string filename, IVsHierarchy hierarchy);
        
        /// <summary>
        /// Clears the entire error list.
        /// </summary>
        void ClearErrorListItems();
    }
}
