using System.Runtime.InteropServices;

namespace BenjaminSchroeter.Flow.HardwareDescription
{
    /// <summary>
    /// This interface provides the UI and Project interaction
    /// to import a driver package.
    /// The Hardware Dsl Editor uses this service when the user
    /// requests to add a driver. The Service must determine which driver
    /// (with a file dialog or whatever?), add all files to the
    /// Project and than provides the .driverinfo file for the Hardware 
    /// Description Dsl Editor.
    /// </summary>
    [Guid("FD9443BF-2A6C-4027-AFEE-B3F113CCD15A")]
    [ComVisible(true)]
    public interface IImportDriverService
    {
        string GetDriverInfo();
        void ImportDriverToProject();
        void Close();
    }
}
