﻿using System.Collections.Generic;
using System.Xml.Linq;

namespace BenjaminSchroeter.Dsl.DirectiveProcessors
{
    public class VsProjectFile
    {
        public XDocument Document { get; private set; }
        public string FileName { get; private set; }

        public VsProjectFile(XDocument doc)
        {
            this.Document = doc;
        }

        public VsProjectFile(string fileName)
        {
            this.Document = XDocument.Load(fileName);
            this.FileName = fileName;
        }

        public string[] VcprojGetAllFiles()
        {
            if (Document.Root != null)
            {
                XElement root = Document.Root.Element("Files");

                List<string> files = new List<string>();

                if ( root != null)
                    VcprojFindFiles(root, files);

                return files.ToArray();
            }

            return new string[] {};
        }

        private static void VcprojFindFiles(XElement root, List<string> files)
        {
            foreach (XElement file in root.Elements("File"))
            {
                XAttribute att = file.Attribute("RelativePath");
                if (att != null) 
                    files.Add(att.Value);
                
                VcprojFindFiles(file, files);
            }

            foreach (XElement filter in root.Elements("Filter"))
                VcprojFindFiles(filter, files);
        }
    }
}
