using System.Collections.Generic;
using System.IO;
using System.Text;
using Microsoft.VisualStudio.TextTemplating;

namespace BenjaminSchroeter.Dsl.DirectiveProcessors
{
    public class XmlFileDirectiveProcessor : FileDirectiveProcessorBase
    {
        protected override string DIRECTIVE_NAME
        {
            get { return "XmlFile"; }
        }

        protected override string CreateInjectingCode(IDictionary<string, string> arguments)
        {
            string filename;
            if ( !arguments.TryGetValue("FileName", out filename) )
                throw new DirectiveProcessorException("Required argument 'FileName' not specified.");
            if ( string.IsNullOrEmpty(filename) )
                throw new DirectiveProcessorException("argument 'FileName' is null or empty.");

            string fullPath = Path.Combine(Path.GetDirectoryName(templateFile), filename);

            StringBuilder sb = new StringBuilder();
            sb.AppendLine("private XDocument _xmlFile;");
            sb.AppendLine("private XDocument XmlFile");
            sb.AppendLine("{");
            sb.AppendLine("   get");
            sb.AppendLine("   {");
            sb.AppendLine("      if (_xmlFile == null)");
            sb.AppendLine("         _xmlFile = XDocument.Load(@\"" + fullPath + "\");");
            sb.AppendLine("      return _xmlFile;");
            sb.AppendLine("   }");
            sb.AppendLine("}");
            return sb.ToString();
        }
    }
}