﻿using System.Collections.Generic;
using System.ComponentModel.Design;
using System.Linq;

namespace BenjaminSchroeter.VsxTools
{
    /// <summary>
    /// Helper functions for CommandSet
    /// </summary>
    public class CommandSetHelper
    {
        /// <summary>
        /// Removes a Command with a given CommandID from a command set.
        /// </summary>
        /// <remarks>To use with the CommandSet class</remarks>
        /// <param name="cmdList">The list of commands.</param>
        /// <param name="commandID">The command ID.</param>
        public static void RemoveFromCommandSet(IList<MenuCommand> cmdList, CommandID commandID)
        {
            // find the command
            MenuCommand cmd = cmdList.FirstOrDefault(c => c.CommandID == commandID);
            
            // if found, remove it
            if (cmd != null)
                cmdList.Remove(cmd);
        }
    }
}
