﻿using System.Collections.Generic;

namespace BenjaminSchroeter.Dsl.Graphs
{
    /// <summary>
    /// Abstract class to represent graphs
    /// </summary>
    /// <typeparam name="V">Type of Vertices</typeparam>
    /// <typeparam name="E">Type of Edges</typeparam>
    /// <remarks>The current implementations does not care about the Edges since the edges are not used in the underlaying algorithms</remarks>
    public abstract class Graph<V,E>
    {
        /// <summary>
        /// All Vertices of this instance.
        /// </summary>
        public abstract IEnumerable<V> Vertices();

        /// <summary>
        /// Children the specified vertex.
        /// </summary>
        /// <param name="v">The v.</param>
        /// <returns></returns>
        public abstract IEnumerable<V> Children(V v);

        /// <summary>
        /// Gets a value indicating whether this graph is directed is directed.
        /// </summary>
        /// <value>
        /// 	<c>true</c> if this instance is directed; otherwise, <c>false</c>.
        /// </value>
        public abstract bool IsDirected { get; }
        
        //   public abstract IList<E> Edges(V v);
    }
}