﻿using System;
using System.Collections.Generic;
using EnvDTE;

namespace BenjaminSchroeter.VsxTools
{
    /// <summary>
    /// Some extension methods for the EnvDTE.Project type
    /// </summary>
    public static class ProjectExtensions
    {
        /// <summary>
        /// Finds all files in a given project.
        /// </summary>
        /// <param name="project">The project.</param>
        public static List<ProjectItem> FindAllFiles(this Project project)
        {
            List<ProjectItem> items = new List<ProjectItem>();
            foreach (ProjectItem item in project.ProjectItems)
            {
                items.Add(item);
                FindAllFiles(item, items);
            }

            return items;
        }
        private static void FindAllFiles(ProjectItem root, List<ProjectItem> items)
        {
            foreach (ProjectItem item in root.ProjectItems)
            {
                items.Add(item);
                FindAllFiles(item, items);
            }
        }

        /// <summary>
        /// Determines whether the give project is a VC++ project.
        /// </summary>
        /// <param name="project">The project.</param>
        /// <returns><c>true</c> if the give project is a VC++ project; otherwise, <c>false</c>.
        /// </returns>
        public static bool IsCppProject(this Project project)
        {
            return project.Kind.Equals("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}", StringComparison.InvariantCultureIgnoreCase);
        }
    }
}
