using System.Text;
using Microsoft.VisualStudio.TextTemplating.VSHost;

namespace BenjaminSchroeter.Flow.UiSupportPackage
{
    /// <summary>
    /// This Callback is used ITextTemplating service to report errors and 
    /// the new FielExtension and the Encoding of the output.
    /// </summary>
    internal class TextTemplatingCallback : ITextTemplatingCallback
    {
        public string FileExtension { get; private set; }
        public Encoding Encoding { get; private set; }

        public int ErrorCount { get; private set; }

        public TextTemplatingCallback()
        {
            this.Encoding = Encoding.UTF8;
        }

        public void ErrorCallback(bool warning, string message, int line, int column)
        {
            if (!warning)
                ErrorCount++;
        }

        public void SetFileExtension(string extension)
        {
            this.FileExtension = extension;
        }

        public void SetOutputEncoding(Encoding encoding, bool fromOutputDirective)
        {
            if ( encoding != null && !fromOutputDirective)
                return;

            this.Encoding = encoding;
        }
    }
}
